﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.801
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#Extends: android.accessibilityservice.AccessibilityService	
#End Region

'https://developer.android.com/guide/topics/ui/accessibility/service

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private counter As Long
End Sub

Sub Service_Create
	counter = counter + 1
	Log($"svc_accessibility Service_Create with counter: ${counter}. $DateTime{DateTime.Now}"$)
End Sub

Sub Service_Start (StartingIntent As Intent)
	Log($"svc_accessibility Service_Start! $DateTime{DateTime.Now}"$)
	Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
	
End Sub

Sub Service_Destroy
	Log($"svc_accessibility Service_Destroy! $DateTime{DateTime.Now}"$)
End Sub

Public Sub HelloWorld
	Log($"Hello world! $DateTime{DateTime.Now}"$)
End Sub

Public Sub accessibility_event(aList As List)
	Log("accessibility_event")
	Log($"aList[0]: ${aList.Get(0)} | aList[1]: ${aList.Get(1)} | aList[2]: ${aList.Get(2)}"$)
End Sub

public Sub RunPerformGlobalAction(action As Int)
	Dim nativeMe As JavaObject
	nativeMe.InitializeContext
	nativeMe.RunMethod("PerformGlobalAction", Array(action))
End Sub

public Sub RunDispatchGesture
	Dim nativeMe As JavaObject
	nativeMe.InitializeContext
	nativeMe.RunMethod("DispatchGesture", Null)
End Sub


#if Java
import android.accessibilityservice.AccessibilityService;
import android.content.ComponentName; 
import android.view.accessibility.AccessibilityEvent;
import android.graphics.Path;
import android.accessibilityservice.GestureDescription;

import anywheresoftware.b4a.BA;

	@Override
	public void onServiceConnected() {
		BA.Log("****************svc_accessibility's onServiceConnected() was called!***********");
	}

    @Override
    public void onAccessibilityEvent(AccessibilityEvent event) {
		BA.Log("onAccessibilityEvent. Event is " + event.getEventType());
		
		CharSequence pkgChars = event.getPackageName();
		CharSequence classChars = event.getClassName();
		String pkgName = pkgChars == null ? "" : pkgChars.toString();
		String className = classChars == null ? "" : classChars.toString();
		String activityName;
		if (pkgName != "" && className != "") {
			ComponentName componentName = new ComponentName(pkgName, className);
			activityName = componentName.flattenToShortString();
		} else {
			activityName = "";
		}

		if (processBA !=null) {
			BA.Log("processBA is not null!");
			
			anywheresoftware.b4a.objects.collections.List values = new anywheresoftware.b4a.objects.collections.List();
			values.Initialize();
			values.Add(pkgName);
			values.Add(className);
			values.Add(activityName);

			try {
				processBA.raiseEvent(this, "accessibility_event", values);
			} catch (Exception e) {
				BA.Log(e.toString());
			}
		}
    }

    @Override
    public void onInterrupt() {
    }

	public void PerformGlobalAction(int action) {
		boolean Result;
		Result = super.performGlobalAction(action) ;
		BA.Log("Java PerformGlobalAction: action = " + action + ", Result = " + Result);
	}

	public void DispatchGesture() {
		boolean Result;
		GestureDescription.Builder gestureBuilder = new GestureDescription.Builder();
		Path path= new Path();
		path.moveTo(500, 500);
		gestureBuilder.addStroke(new GestureDescription.StrokeDescription(path, 0, 50));
		Result = super.dispatchGesture(gestureBuilder.build(), null, null) ;
		BA.Log("Java DispatchGesture: Result = " + Result);
	}

#End If